#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <termios.h>
#include <unistd.h>
#include "dSFMT.h"

// #define Npop 500
// #define Ngen 400
 #define n_simu 500
// #define k0 0.01

// Ordre : Npop Ngen k0 mu0 imax
// gcc -std=c99 -DDSFMT_MEXP=19937 -o even_d demog_even_d.c dSFMT.c -lm

//////////////////////////////////////////////
void rdtsc()
{
    __asm__ __volatile__("rdtsc");
}


/////////////////////////////////////:::

void **malloc2d (unsigned int num, unsigned int size)
{
    char **c, **d, *p;
    if(!num || !size) return 0; //<- à retirer dans un code sûr
    
    if(!(c = (char**)malloc((num*size)+(num*sizeof(char*))))) return 0;
    d = c; p = (char*)(c+num);
    
    do *d++ = p+(--num*size); while(num);
    // OU
    // do *(d+(--num)) = p+(num*size); while(num);
    
    return (void**)c;
}

/////////////////////////////////////:::


int main(int argc, char *argv[])
{
int seed;
dsfmt_t dsfmt;

    if (argc >= 2) {
        seed = strtol(argv[1], NULL, 10);
    } else {
        seed = time(NULL);
    }
    init_gen_rand(seed);

seed=(unsigned)time(NULL);

    dsfmt_init_gen_rand(&dsfmt, seed);
/////////////////

int nb_repro,i,i2,j,k,nEnf,Np,res,nexp,Nptot,*Np_vec,Np_temp,Np_tempo,Npop,Ngen,imax;
float mu0,pmut,**D,**M,**Trepro,*vec,s,t,T0,tau,p,p2,x,Tlim,*cumul,**data,*Tmax_vec,k0,*age_maxi,numero;

pmut=0.1; // Probabilité de mutation des alphas
nb_repro=10.0; // Nombre de reproduction/unité de temps

Npop=atoi(argv[1]); //500
Ngen= atoi(argv[2]); //400
k0=atof(argv[3]); //0.1
mu0=atof(argv[4]); //0.0001
imax=atof(argv[5]); // 100

k0=k0/imax;



// Paramètres et initialisation


age_maxi=malloc(n_simu*sizeof(float));
D=(float **)malloc2d(Ngen,Npop*sizeof(float));
M=(float **)malloc2d(Ngen,Npop*sizeof(float));
Trepro=(float **)malloc2d(Ngen,Npop*sizeof(float));
data=(float **)malloc2d(n_simu*Npop,4*sizeof(float));

cumul=malloc(Npop*sizeof(float));
vec=malloc(Npop*sizeof(float));
Tmax_vec=malloc(n_simu*sizeof(float));
Np_vec=malloc(n_simu*sizeof(int));

Nptot=0;

for (i=0;i<n_simu*Npop;i++){
  for (j=0;j<4;j++){
    data[i][j]=0.0;
  }
}



for (nexp=0;nexp<n_simu;nexp++){
if (nexp%50==0)
{printf("nexp=%d\n",nexp);}

  for (i=0;i<Ngen;i++){
    for(j=0;j<Npop;j++){
    D[i][j]=0.0;
    M[i][j]=0.0;
    Trepro[i][j]=0.0;
    }
  }

  for(i=0;i<Npop;i++){
  D[0][i]=dsfmt_gv_genrand_close_open();
  vec[i]=0.0;}





  Np=Npop;

  for (i=0;i<Ngen;i++){

//     printf("Np=%d et generation %d\n",Np,i);
    
    t=0;

    for(i2=0;i2<Npop;i2++){
    vec[i2]=0.0;}



    nEnf=0;
  ///////////////////////////////////////
  //// Calculs des instants de mort 
  
    for (k=0;k<Np;k++){
      x=dsfmt_gv_genrand_close_open();
      T0=-log(x);
     if((D[i][k]*k0)>0.0){ M[i][k]=1/(k0*D[i][k])*log(1+k0*D[i][k]*T0/mu0);}
      else {
      printf("ici !\n");
      M[i][k]=T0/mu0;}
      if(i==Ngen-1) {
      data[k+Nptot][0]=D[i][k];
      data[k+Nptot][1]=M[i][k];
      data[k+Nptot][2]=nexp;
      if (Ngen>1) {
      data[k+Nptot][3]=Trepro[i-1][k];}

      Np_tempo=Np;
      }
  //     printf("Alpha %f et lifespan %f\n",D[i][k],M[i][k]);
    }
    Tlim=0;
    for (k=0;k<Np;k++){
      if(M[i][k]>Tlim) {Tlim=M[i][k];}
    }

  ////
  /////////////////////////////////////////

    while (nEnf<Npop){
  
  ///////////////////////////
  //// Tirage de l'instant de prochaine reproduction
  
  x=dsfmt_gv_genrand_close_open();
  tau=-log(x)/nb_repro;
  t=t+tau;
  Trepro[i][nEnf]=t;
  ////
  ////////////////////////// 

  
    //////////////////////////////////////////// 
  //// Tirage d'un individu pour se reproduire


    for (k=0;k<Np;k++){
      if (M[i][k]>t) {
      vec[k]=D[i][k];}
      else {
      vec[k]=0;}
    }

    s=0;
    for (i2=0;i2<Np;i2++){
    s=s+vec[i2];
    }

    cumul[0]=vec[0];

    for (k=1;k<Np;k++){
      cumul[k]=cumul[k-1]+vec[k];
    }
    
    if (s==0){ 
      break;
    }
    p=dsfmt_gv_genrand_close_open()*s;
    
    for (k=0;k<Np;k++){
      if (p<cumul[k]){
	res=k;
	break;
      }
    }


    
    if (i<(Ngen-1)){
    p2=dsfmt_gv_genrand_close_open();
    if (p2>pmut){
    D[i+1][nEnf]=D[i][res];}
    else {
    D[i+1][nEnf]=dsfmt_gv_genrand_close_open();}
    }
    nEnf=nEnf+1;
  ////  
  /////////////////////////////////////////////  
    }
  age_maxi[nexp]=t;
  Np=nEnf;

  }

  
  Np_vec[nexp]=Np;


    Tlim=0;
    for (k=0;k<Np;k++){
      if(data[k+Nptot][1]>Tlim) {Tlim=data[k+Nptot][1];}
    }
  Tmax_vec[nexp]=Tlim;
  Nptot=Nptot+Np_tempo;
}



char filename[255];
  FILE *f2;
  sprintf((char *) &filename,"alpha_lifespan_k0_%f_Npop_%d_ngen_%d_pmut_%f_mu0_%f.dat",k0,Npop,Ngen,pmut,mu0);
  f2=fopen(filename,"w");
printf("Nptot=%d\n",Nptot);
  numero=0.0;

  for (i=0;i<Nptot;i++){
  if (data[i][2]==numero) {
    if ((data[i][1]) < age_maxi[(int)floor(numero)]){
      if (f2) fprintf(f2,"%f %f %f %f %f 1\n",data[i][0],data[i][1],data[i][2],data[i][3],age_maxi[(int)floor(numero)]);
    }
    else { if (f2) fprintf(f2,"%f %f %f %f %f -1\n",data[i][0],data[i][1],data[i][2],data[i][3],age_maxi[(int)floor(numero)]);}
  }
  else { 
  numero=numero+1.0;
    if (data[i][1]<age_maxi[(int)floor(numero)]){
    if (f2) fprintf(f2,"%f %f %f %f %f 1\n",data[i][0],data[i][1],data[i][2],data[i][3],age_maxi[(int) floor(numero)]);
    }
    else {if (f2) fprintf(f2,"%f %f %f %f %f -1\n",data[i][0],data[i][1],data[i][2],data[i][3],age_maxi[(int) floor(numero)]);}
  }
  }

  fclose(f2),f2=NULL;


free(age_maxi);
free(Tmax_vec);
free(data);
free(Np_vec);
free(cumul);
free(vec);
free(M);
free(D);
free(Trepro);

return 0;
}